"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _defineProperty = require("babel-runtime/core-js/object/define-property");

var _defineProperty2 = _interopRequireDefault(_defineProperty);

var _keys = require("babel-runtime/core-js/object/keys");

var _keys2 = _interopRequireDefault(_keys);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _Field = require("./Field");

var _Field2 = _interopRequireDefault(_Field);

var _Operation = require("./Operation");

var _Operation2 = _interopRequireDefault(_Operation);

var _Parameter = require("./Parameter");

var _Parameter2 = _interopRequireDefault(_Parameter);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * @property {string} name            - The name of the resource
 * @property {string} url             - The base URL for this resource
 */
var Resource =

/**
 * @param {string}          name
 * @param {string}          url
 * @param {ResourceOptions} options
 */
function Resource(name, url) {
  var _this = this;

  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  (0, _classCallCheck3.default)(this, Resource);

  this.name = name;
  this.url = url;

  (0, _keys2.default)(options).forEach(function (key) {
    (0, _defineProperty2.default)(_this, key, {
      readable: true,
      writable: true,
      enumerable: true,
      value: options[key]
    });
  });
};

exports.default = Resource;